<?

function hmac ($key, $data)
{
// RFC 2104 HMAC implementation for php.
// Creates an md5 HMAC.
// Eliminates the need to install mhash to compute a HMAC
// Hacked by Lance Rushing

  $b = 64; // byte length for md5
  if (strlen($key) > $b) {
    $key = pack("H*",md5($key));
  }
  $key = str_pad($key, $b, chr(0x00));
  $ipad = str_pad('', $b, chr(0x36));
  $opad = str_pad('', $b, chr(0x5c));
  $k_ipad = $key ^ $ipad ;
  $k_opad = $key ^ $opad;

  return md5($k_opad . pack("H*",md5($k_ipad . $data)));
}

function keygen($limit)
{
  return substr(md5(date("d.m.Y.H.i.s").rand(1,1000000)) , 0 , $limit);
}

include "./config/config.php";

session_start();
if(session_is_registered("uzytkownik")) {
  $message='<font color="green">Wylogowany.</font>';
  setcookie('autologin',"");
  setcookie('target',"");
} else {
  $message="";
  if($_COOKIE['autologin'] != "") {
    if($_COOKIE['autologin']==$md5_pass) {
      session_register("uzytkownik");
      header("location:${_COOKIE['target']}.php");
      exit;
    }
  }
}

session_destroy();
       
if(isset($_POST['login_grey'])) {
  $login=$_POST['login_grey'];
  $target='greylist';
}
if(isset($_POST['login_panel'])) {
  $login=$_POST['login_panel'];
  $target='panel';
}
if($login) {
  $uzytkownik='admin';
  $haslo_md5_hmac=$_POST['haslo_md5_hmac'];

  $pass_md5_hmac=hmac($_POST['klucz'],$md5_pass);

  if($haslo_md5_hmac==$pass_md5_hmac) {
    if(isset($_POST['target'])) {
      setcookie('autologin',$md5_pass,time()+1209600);
      setcookie('target',$_POST['target'],time()+1209600);
    }
    session_register("uzytkownik");
    if($force_new_pass) {
      header("location:chpass.php");
      exit;
    } else {
      header("location:${target}.php");
      exit;
    }
  } else {
    $message='<font color="red">Nieprawidowe haso !</font>';
  }
}

$klucz=keygen(10);

?>
<html>
<head>
<title>HERMES - panel zarzdzania biaymi, czarnymi i szarymi listami - logowanie</title>
<meta http-equiv="Content-type" content="text/html;charset=ISO-8859-2">
<style type="text/css">
body      { font-family: Tahoma,Arial,sans-serif; margin-top:20px; font-size:12px; }
fieldset  { padding:10px; color:#07d; font-size:12px; font-weight:bold; background-color:#eee; }
h2 { color:#00a; font-size:15px; text-align:center; font-family:Tahoma,Arial,sans-serif; }
td        { font-family: Tahoma,Arial,sans-serif; font-size:12px; }
</style>
<script language="JavaScript" src="md5.js" type="text/javascript"></script>
</head>
<body onload="document.getElementById('haslo').focus()">
 <div style="margin-top:50px;" align="center">
  <h2>HERMES panel - logowanie</h2>
  <form id="form1" name="form1" method="post" action="<? echo $PHP_SELF; ?>" onSubmit="document.form1.haslo_md5_hmac.value=hex_hmac_md5(document.form1.klucz.value,hex_md5(document.form1.haslo.value));this.haslo.value='';">
  <table><tr><td align="center"><fieldset>
   <legend>Haso:</legend>
   <input name="haslo" type="password" id="haslo" /><br><br>
   <input name="login_grey" type="submit" id="login" value="Greylist" />
   <input name="login_panel" type="submit" id="login" value="Black&White-list" />
   <input name="haslo_md5_hmac" type="hidden" value="" />
   <input name="klucz" type="hidden" value="<? echo $klucz; ?>" />
   </fieldset></td></tr>
   <tr><td style="padding-top:15px;"><input name="autologin" type="checkbox" onClick="enableRadio();" /> Zaloguj automatycznie i przejd do:</td></tr>
   <tr><td style="padding-left:35px;"><input name="target" type="radio" id="grey" value="greylist" checked="checked" /> Greylist</td></tr>
   <tr><td style="padding-left:35px;"><input name="target" type="radio" id="black" value="panel" /> Black&White-list</td></tr>
  </table>
  </form>
  <br>
  <? echo $message; ?>
 </div>
 <script language="javascript">
 <!-------
 function enableRadio() {
   document.form1.grey.disabled=!document.form1.autologin.checked;
   document.form1.black.disabled=!document.form1.autologin.checked;
 }
 enableRadio();
 // ------- >
 </script>
</body>
</html>
